﻿Imports MRK.PowerExcel
Imports System.Reflection


''' <summary>
''' パワーエクセルサンプル画面（詳細）
''' </summary>
''' <remarks></remarks>
Public Class frmDetail

#Region "メンバ"

	''' <summary>
	''' 請求先トラン
	''' </summary>
	''' <remarks>
	''' DBのテーブルに見立てて、ここからグリッドに表示するDataTableを取得します
	''' </remarks>
	Private T_Seikyu As New SeikyuDataSet.SeikyusakiListDataTable

	''' <summary>
	''' 請求明細トラン
	''' </summary>
	''' <remarks></remarks>
	Private T_SeikyuDetail As New SeikyuDataSet.SeikyuDetailDataTable

	''' <summary>
	''' 自社情報トラン
	''' </summary>
	''' <remarks></remarks>
	Private T_JishaInfo As New SeikyuDataSet.JishaInfoDataTable

	''' <summary>
	''' 請求コード
	''' </summary>
	''' <remarks></remarks>
	Private mSeikyuCD As String

#End Region

#Region "イベント"

	''' <summary>
	''' 請求コードプロパティ
	''' </summary>
	''' <value></value>
	''' <returns></returns>
	''' <remarks></remarks>
	Public Property SeikyuCD() As String
		Get
			Return mSeikyuCD
		End Get
		Set(ByVal value As String)
			mSeikyuCD = value
		End Set
	End Property

	''' <summary>
	''' フォームロード
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks></remarks>
	Private Sub frmDetail_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
		Try


			'元テーブルを読み込んでおきます
			Me.T_Seikyu.ReadXml("..\..\..\Doc\SeikyuList.xml")
			Me.T_JishaInfo.ReadXml("..\..\..\Doc\JishaData.xml")
			Me.T_SeikyuDetail.ReadXml("..\..\..\Doc\SeikyuDetail.xml")



			'ヘッダを表示します
			Dim drH() As SeikyuDataSet.SeikyusakiListRow
			drH = Me.T_Seikyu.Select("SeikyusakiCD = '" & Me.mSeikyuCD & "'")

			Me.lblSeikyusakiName.Text = drH(0).SeikyusakiName
			Me.lblTantosha.Text = drH(0).Tantosha
			Me.lblTel.Text = drH(0).Tel


			'グリッドを表示します
			Dim drD() As SeikyuDataSet.SeikyuDetailRow
			drD = Me.T_SeikyuDetail.Select("SeikyusakiCD = '" & Me.mSeikyuCD & "'")

			If drD.Length = 0 Then
				MsgBox("明細データが存在しません")
			Else

				Dim dtMain As New SeikyuDataSet.GridDetailDataTable

				For Each buf As SeikyuDataSet.SeikyuDetailRow In drD

					Dim drMain As SeikyuDataSet.GridDetailRow
					drMain = dtMain.NewGridDetailRow

					drMain.請求先CD = buf.SeikyusakiCD
					drMain.項目 = buf.Seq
					drMain.商品名称 = buf.ShohinName
					drMain.数量 = buf.Suryo
					drMain.単位 = buf.Tani
					drMain.単価 = buf.Tanka
					drMain.金額 = buf.Kingaku

					dtMain.AddGridDetailRow(drMain)
				Next

				Me.grdMain.DataSource = Nothing
				Me.grdMain.DataSource = dtMain

			End If

		Catch ex As Exception
			MsgBox(ex.Message)
		End Try
	End Sub

	''' <summary>
	''' 参照
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks></remarks>
	Private Sub btnOutput_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOutput.Click
		Try

			Dim dlg As New SaveFileDialog
			dlg.Filter = "EXCELファイル(*.xls)|*.xls;*.xls|すべてのファイル(*.*)|*.*"
			dlg.FilterIndex = 2

			'ファイル保存ダイアログを開きます
			If dlg.ShowDialog = System.Windows.Forms.DialogResult.Cancel Then
				Return
			End If

			'拡張子を付加し、テキストに表示します
			If dlg.FileName.Substring((dlg.FileName.Length - 4), 1) <> "." Then
				Me.txtOutputPath.Text = dlg.FileName & ".xls"
			Else
				Me.txtOutputPath.Text = dlg.FileName
			End If

			'相対参照を行っているのでカレントフォルダをアセンブリに戻しておきます
			System.Environment.CurrentDirectory = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location)

		Catch ex As Exception
			MsgBox(ex.Message)
		End Try
	End Sub

	''' <summary>
	''' 閉じる
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks></remarks>
	Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
		Me.Close()
	End Sub

	''' <summary>
	''' 出力
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks></remarks>
	Private Sub btnExcelOut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExcelOut.Click
		Try

			If Me.txtOutputPath.Text = "" Then
				MsgBox("出力先を選択して下さい")
				Return
			End If


			'#################################################################
			'パワーエクセルを使用し請求書を作成します
			'元々用意されている請求書のテンプレートファイルを読み込み
			'ユーザーが選択したファイルパスに出力します
			'テンプレートがあれば、設定するプロパティは、ほぼ座標と値のみなのでスムーズです
			'参照設定に「PowerExcel」と「Microsoft.Office.Interop.Excel(Ver1.2.0.0.0)」を追加し
			'MRK.PowerExcelをImportsしています
			'#################################################################


			'パワーエクセルクラスインスタンス
			'この変数に対して、各プロパティを設定していき
			'最後にRunOperationで出力します
			Dim pwExcel As New PowerExcel


			'【１】PowerExcel本体のプロパティを設定します
			Me.SetPowerExcel(pwExcel)

			'【２】単一セルエージェントにより、表以外の文字列を設定します
			Me.SetOneCellAgent(pwExcel)

			'【３】データテーブルエージェントにより、表を作成します
			Me.SetDataTableAgent(pwExcel)

			'【４】各プロパティ設定が完了したので、描画を実行します
			pwExcel.RunOperation()


			'新規シートに全ての請求先の明細の控えを作成してみます
			'################################################################
			'全エージェントをクリア
			pwExcel.ClearAllAgent()
			'シートを変更します（この場合新規追加、テンプレートに存在するシート名の場合は、そのシートがアクティブになります）
			pwExcel.NextSheet("全明細データ控え")
			'明細データテーブルをフォーマットなしで作成
			Me.SetAllDetailPrint(pwExcel)
			'描画実行
			pwExcel.RunOperation()
			'################################################################

			MsgBox("請求書を指定ファイルに出力しました。")


		Catch ex As Exception
			MsgBox(ex.Message)
		End Try
	End Sub

#End Region

#Region "プライベートメソッド"

	''' <summary>
	''' パワーエクセルプロパティ設定
	''' </summary>
	''' <param name="pwExcel"></param>
	''' <remarks></remarks>
	Private Sub SetPowerExcel(ByVal pwExcel As PowerExcel)
		Try

			'テンプレートを読み込み、ファイル名固定で出力するモードに設定します
			pwExcel.FileMode = PowerExcel.FileModeEnum.OpenFileAndNomalSave

			'ユーザーが選択した保存先ファイルフルパスを設定します
			pwExcel.FilePath = Me.txtOutputPath.Text

			'シート名を任意に決定します
			pwExcel.SheetName = "請求書"

			'テンプレート
			pwExcel.TemplateFilePath = "..\..\..\Doc\請求書テンプレート.xls"
			pwExcel.TemplateSheetName = "Sheet1"

		Catch ex As Exception
			MsgBox(MethodBase.GetCurrentMethod().ToString() & "でエラーが発生しました")
			Throw ex
		End Try

	End Sub

	''' <summary>
	''' 単一セルエージェントプロパティ設定
	''' </summary>
	''' <param name="pwExcel"></param>
	''' <remarks></remarks>
	Private Sub SetOneCellAgent(ByVal pwExcel As PowerExcel)

		Try

			'エージェントの内部クラスであるArgumentInfoをインスタンス化します
			Dim argInfo As New AgentForOneCell.ArgumentInfo

			'引数情報クラスのプロパティは全て「m」で始まります
			'請求書はテンプレートを読み込んでいるので、位置情報とValue値のみ設定していきます

			argInfo.mIntRow = 5
			argInfo.mIntCol = 10
			argInfo.mStrValue = Now.ToString("yyyy/MM/dd")
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)

			argInfo = New AgentForOneCell.ArgumentInfo
			argInfo.mIntRow = 6
			argInfo.mIntCol = 11
			argInfo.mStrValue = "123456"
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)


			'請求先情報を設定していきます
			Dim drH() As SeikyuDataSet.SeikyusakiListRow
			drH = Me.T_Seikyu.Select("SeikyusakiCD = '" & Me.mSeikyuCD & "'")

			'請求先名称
			argInfo = New AgentForOneCell.ArgumentInfo
			argInfo.mIntRow = 8
			argInfo.mIntCol = 2
			argInfo.mStrValue = drH(0).SeikyusakiName & "　御中"
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)
			'郵便番号
			argInfo = New AgentForOneCell.ArgumentInfo
			argInfo.mIntRow = 10
			argInfo.mIntCol = 3
			argInfo.mStrValue = drH(0).Post
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)
			'住所
			argInfo = New AgentForOneCell.ArgumentInfo
			argInfo.mIntRow = 11
			argInfo.mIntCol = 2
			argInfo.mStrValue = drH(0).Jusho
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)
			'TEL
			argInfo = New AgentForOneCell.ArgumentInfo
			argInfo.mIntRow = 13
			argInfo.mIntCol = 3
			argInfo.mStrValue = drH(0).Tel
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)
			'FAX
			argInfo = New AgentForOneCell.ArgumentInfo
			argInfo.mIntRow = 14
			argInfo.mIntCol = 3
			argInfo.mStrValue = drH(0).Fax
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)
			'部署名
			argInfo = New AgentForOneCell.ArgumentInfo
			argInfo.mIntRow = 15
			argInfo.mIntCol = 2
			argInfo.mStrValue = drH(0).Busho
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)
			'担当者
			argInfo = New AgentForOneCell.ArgumentInfo
			argInfo.mIntRow = 17
			argInfo.mIntCol = 3
			argInfo.mStrValue = drH(0).Tantosha
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)


			'自社情報を設定していきます
			'自社名
			argInfo = New AgentForOneCell.ArgumentInfo
			argInfo.mIntRow = 10
			argInfo.mIntCol = 8
			argInfo.mStrValue = Me.T_JishaInfo(0).JishaName
			argInfo.mCellFormat = AgentBase.CellFormatEnum.StringFormat
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)
			'郵便番号
			argInfo = New AgentForOneCell.ArgumentInfo
			argInfo.mIntRow = 12
			argInfo.mIntCol = 9
			argInfo.mStrValue = Me.T_JishaInfo(0).Post
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)
			'住所
			argInfo = New AgentForOneCell.ArgumentInfo
			argInfo.mIntRow = 13
			argInfo.mIntCol = 8
			argInfo.mStrValue = Me.T_JishaInfo(0).Jusho
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)
			'TEL
			argInfo = New AgentForOneCell.ArgumentInfo
			argInfo.mIntRow = 15
			argInfo.mIntCol = 9
			argInfo.mStrValue = Me.T_JishaInfo(0).Tel
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)
			'FAX
			argInfo = New AgentForOneCell.ArgumentInfo
			argInfo.mIntRow = 16
			argInfo.mIntCol = 9
			argInfo.mStrValue = Me.T_JishaInfo(0).Fax
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)
			'部署
			argInfo = New AgentForOneCell.ArgumentInfo
			argInfo.mIntRow = 17
			argInfo.mIntCol = 8
			argInfo.mStrValue = Me.T_JishaInfo(0).Busho
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)
			'社員名
			argInfo = New AgentForOneCell.ArgumentInfo
			argInfo.mIntRow = 19
			argInfo.mIntCol = 10
			argInfo.mStrValue = Me.T_JishaInfo(0).Tantosha
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)
			'振り込み先
			argInfo = New AgentForOneCell.ArgumentInfo
			argInfo.mIntRow = 49
			argInfo.mIntCol = 2
			argInfo.mStrValue = Me.T_JishaInfo(0).bank
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)




		Catch ex As Exception
			MsgBox(MethodBase.GetCurrentMethod().ToString() & "でエラーが発生しました")
			Throw ex
		End Try

	End Sub

	''' <summary>
	''' データテーブルエージェントプロパティ設定
	''' </summary>
	''' <param name="pwExcel"></param>
	''' <remarks></remarks>
	Private Sub SetDataTableAgent(ByVal pwExcel As PowerExcel)
		Try
			'データテーブルを作成します
			Dim dtBuf As New SeikyuDataSet.SeikyuDetailDataTable
			Dim drD() As SeikyuDataSet.SeikyuDetailRow
			drD = Me.T_SeikyuDetail.Select("SeikyusakiCD = '" & Me.mSeikyuCD & "'")
			For Each dr As SeikyuDataSet.SeikyuDetailRow In drD
				dtBuf.Rows.Add(dr.ItemArray)
			Next

			'請求書はテンプレートを読み込むので、ほぼデータテーブルのみの設定でOKです

			'エージェントの内部クラスであるArgumentInfoをインスタンス化します
			Dim argInfo As New AgentForDataTable.ArgumentInfo
			'データテーブルを設定
			argInfo.mDtMain = dtBuf
			'ヘッダはテンプレートに書かれてあるので非表示にします
			argInfo.mIsHeader = False

			argInfo.mIntStartRow = 23
			argInfo.mIntStartCol = 2


			'#######################################################################
			'次に、このデータテーブルのエクセル列情報を追加していきます
			'mIntColはエクセルの表の、1から始まるインデックスを設定します
			'データテーブルのインデックスではありません、又、仮にセルが結合されていたとしても
			'結合を気にせず設定できます
			'例えば、2列目が4列結合されていたとしても、3列目は6ではなく3です
			'#######################################################################
			Dim colInfo As New AgentForDataTable.ArgumentInfo.ExcelColumn
			'2列目（商品名を太字にしてみます）
			colInfo.mIntCol = 2
			colInfo.mFontBold = True

			argInfo.mExcelColumns.Add(colInfo)


			'次に、データテーブルの列情報を設定します
			Dim dtColInfo As New AgentForDataTable.ArgumentInfo.DtColumn
			'非表示列を設定します
			dtColInfo.mColName = dtBuf.SeikyusakiCDColumn.ColumnName
			dtColInfo.mIsDelete = True
			argInfo.mDtColumns.Add(dtColInfo)

			dtColInfo = New AgentForDataTable.ArgumentInfo.DtColumn
			dtColInfo.mColName = dtBuf.ShohinKbnColumn.ColumnName
			dtColInfo.mIsDelete = True
			argInfo.mDtColumns.Add(dtColInfo)


			'リストに追加します
			pwExcel.AgentForDataTable.ArgumentList.Add(argInfo)


		Catch ex As Exception
			MsgBox(MethodBase.GetCurrentMethod().ToString() & "でエラーが発生しました")
			Throw ex
		End Try

	End Sub

	''' <summary>
	''' 明細作成処理
	''' </summary>
	''' <param name="pwExcel"></param>
	''' <remarks></remarks>
	Private Sub SetAllDetailPrint(ByVal pwExcel As PowerExcel)
		Try
			

			'エージェントの内部クラスであるArgumentInfoをインスタンス化します
			Dim argInfo As New AgentForDataTable.ArgumentInfo
			'データテーブルを設定
			argInfo.mDtMain = Me.T_SeikyuDetail
			argInfo.mIntStartCol = 2
			argInfo.mIntStartRow = 2
			argInfo.mIsAutoFit = True
			argInfo.mBorderInfo = AgentBase.BorderTypeEnum.B12_ヘッダ囲んで囲む_横点線_縦線
			argInfo.mBorderWeightInfo = AgentBase.BorderWeightTypeEnum.B04_囲みとヘッダが中線

			'請求先CDは先頭行のみ表示させるため、グループキーカラムへ追加します
			'注意）
			'　　グループキーカラムは複数登録可能ですが
			'　　必ず左の列から順番に設定して下さい
			argInfo.mGroupColumn.Add(Me.T_SeikyuDetail.SeikyusakiCDColumn)


			'リストに追加します
			pwExcel.AgentForDataTable.ArgumentList.Add(argInfo)

		Catch ex As Exception
			MsgBox(MethodBase.GetCurrentMethod().ToString() & "でエラーが発生しました")
			Throw ex
		End Try

	End Sub

#End Region

	
End Class