﻿Imports MRK.PowerExcel
Imports System.Reflection


''' <summary>
''' パワーエクセルサンプル画面（一覧検索）
''' </summary>
''' <remarks></remarks>
Public Class frmSearch

#Region "メンバ"

	''' <summary>
	''' 請求先トラン
	''' </summary>
	''' <remarks>
	''' DBのテーブルに見立てて、ここからグリッドに表示するDataTableを取得します
	''' </remarks>
	Private T_Seikyu As New SeikyuDataSet.SeikyusakiListDataTable

	''' <summary>
	''' 請求明細トラン
	''' </summary>
	''' <remarks></remarks>
	Private T_SeikyuDetail As New SeikyuDataSet.SeikyuDetailDataTable

	''' <summary>
	''' 自社情報トラン
	''' </summary>
	''' <remarks></remarks>
	Private T_JishaInfo As New SeikyuDataSet.JishaInfoDataTable

#End Region

#Region "イベント"

	''' <summary>
	''' フォームロード
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks></remarks>
	Private Sub frmSearch_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
		Try
			'元テーブルを読み込んでおきます
			Me.T_Seikyu.ReadXml("..\..\..\Doc\SeikyuList.xml")
			Me.T_JishaInfo.ReadXml("..\..\..\Doc\JishaData.xml")
			Me.T_SeikyuDetail.ReadXml("..\..\..\Doc\SeikyuDetail.xml")

		Catch ex As Exception
			MsgBox(ex.Message)
		End Try


	End Sub

	''' <summary>
	''' 閉じる
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks></remarks>
	Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
		Me.Close()
	End Sub

	''' <summary>
	''' 検索
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks></remarks>
	Private Sub btnSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSearch.Click

		Try


			Dim dtMain As New SeikyuDataSet.GridListDataTable
			Dim dr() As SeikyuDataSet.SeikyusakiListRow
			Dim strKbn As String = ""
			Dim strName As String = ""
			Dim strWhere As String = ""

			'商品区分を取得します
			If cboKbn.SelectedIndex <> -1 Then
				strKbn = CInt(cboKbn.SelectedIndex + 1).ToString
			End If

			'請求先名を取得します
			strName = Me.txtSeikyusakiName.Text

			'Where句を作成します
			If strKbn <> "" Then
				strWhere = " SyohinKbn = '" & strKbn & "' "
				If strName <> "" Then
					strWhere += " AND SeikyusakiName LIKE '%" & strName & "%'"
				End If
			Else
				If strName <> "" Then
					strWhere += " SeikyusakiName LIKE '%" & strName & "%'"
				End If
			End If

			'検索を実行します
			dr = Me.T_Seikyu.Select(strWhere)

			'データが存在すればグリッド用のデータテーブルに格納します
			If dr.Length <> 0 Then

				For Each buf As SeikyuDataSet.SeikyusakiListRow In dr

					Dim drMain As SeikyuDataSet.GridListRow
					drMain = dtMain.NewGridListRow
					drMain.商品区分 = buf.SyohinKbnName
					drMain.請求先CD = buf.SeikyusakiCD
					drMain.請求先名 = buf.SeikyusakiName
					drMain.担当者 = buf.Tantosha
					drMain.支払予定日 = buf.ShiharaiDate
					drMain.トータル金額 = buf.SeikyuGakuTotal
					drMain.備考 = buf.Biko

					dtMain.AddGridListRow(drMain)
				Next

				Me.grdMain.DataSource = Nothing
				Me.grdMain.DataSource = dtMain

			Else
				MsgBox("対象データなし")
				Return
			End If

		Catch ex As Exception
			MsgBox(ex.Message)
		End Try


	End Sub

	''' <summary>
	''' 詳細表示
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks></remarks>
	Private Sub btnDetail_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDetail.Click
		Try

			If Me.grdMain.SelectedRows.Count <= 0 Then
				MsgBox("行を選択して下さい")
				Return
			End If

			'Dim idx As Integer = Me.grdMain.SelectedRows(0).Index
			Dim cd As String = Me.grdMain.SelectedRows(0).Cells(1).Value.ToString
			Dim frm As New frmDetail

			frm.SeikyuCD = cd
			frm.ShowDialog()

		Catch ex As Exception
			MsgBox(ex.Message)
		End Try
	End Sub

	''' <summary>
	''' 一覧出力
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks></remarks>
	Private Sub btnExcelOut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExcelOut.Click
		Try
			If Me.txtOutputPath.Text = "" Then
				MsgBox("出力先を選択して下さい")
				Return
			End If

			If Me.grdMain.DataSource Is Nothing Then
				MsgBox("一覧を表示して下さい")
				Return
			End If

			'#################################################################
			'パワーエクセルを使用し一覧を表示します
			'この帳票は社内保存用の請求先一覧ですので、テンプレートなしで
			'新規にエクセルファイルを立ち上げます
			'参照設定に「PowerExcel」と「Microsoft.Office.Interop.Excel(Ver1.2.0.0.0)」を追加し
			'MRK.PowerExcelをImportsしています
			'#################################################################

			'パワーエクセルクラスインスタンス
			'この変数に対して、各プロパティを設定していき
			'最後にRunOperationで出力します
			Dim pwExcel As New PowerExcel


			'【１】PowerExcel本体のプロパティを設定します
			Me.SetPowerExcel(pwExcel)

			'【２】単一セルエージェントにより、表以外の文字列を設定します
			Me.SetOneCellAgent(pwExcel)

			'【３】データテーブルエージェントにより、表を作成します
			Me.SetDataTableAgent(pwExcel)

			'【４】連続セルエージェントにより、結合セルの文字列を設定します
			Me.SetRangingCells(pwExcel)

			'表に関係なく列単位の設定を行いたい場合はこのメソッドを参照して下さい
			'表単位の列設定はSetDataTableAgentで行っています
			'Me.SetOneColumnAgent(pwExcel)

			'【５】各プロパティ設定が完了したので、描画を実行します
			pwExcel.RunOperation()

			MsgBox("一覧を指定ファイルに出力しました。")

		Catch ex As Exception
			MsgBox(ex.Message)
		End Try
	End Sub

	''' <summary>
	''' 請求書全出力
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks></remarks>
	Private Sub btnAllPrint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAllPrint.Click
		Try
			If Me.txtOutputPath.Text = "" Then
				MsgBox("出力先を選択して下さい")
				Return
			End If

			If Me.grdMain.DataSource Is Nothing Then
				MsgBox("一覧を表示して下さい")
				Return
			End If

			'#################################################################
			'パワーエクセルを継承した、ページエクセルを使用し
			'全ての請求先の請求書をエクセルに出力します、１請求先１シートでブレイクさせます
			'パワーエクセルにないエージェントが追加されていますのでプロパティの設定などに注意して下さい
			'参照設定に「PowerExcel」と「Microsoft.Office.Interop.Excel(Ver1.2.0.0.0)」を追加し
			'MRK.PowerExcelをImportsしています
			'#################################################################

			'ページエクセルクラスインスタンス
			'この変数に対して、各プロパティを設定していき
			'最後にRunOperationで出力します
			Dim pgExcel As New PageExcel


			'【１】PageExcel本体のプロパティを設定します
			Me.SetPageExcel(pgExcel)

			'【２】単一セルエージェントにより、全シートに共通する部分を作成します
			Me.SetOneCellAgent(pgExcel)

			'【３】ページヘッダエージェントにより、各シートのヘッダ部（請求先名称など）を設定します
			Me.SetPageHeadAgent(pgExcel)

			'【４】データテーブルエージェントにより、表を作成します（ただし表の設定のみでデータテーブルはPageExcel自体のプロパティ内で設定）
			Me.SetDataTableAgent(pgExcel)

			'【５】各プロパティ設定が完了したので、描画を実行します
			pgExcel.RunOperation()

			MsgBox("全請求書を指定ファイルに出力しました。")

		Catch ex As Exception
			MsgBox(ex.Message)
		End Try
	End Sub

	''' <summary>
	''' 参照
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks></remarks>
	Private Sub btnOutput_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOutput.Click

		Try

			Dim dlg As New SaveFileDialog
			dlg.Filter = "EXCELファイル(*.xls)|*.xls;*.xls|すべてのファイル(*.*)|*.*"
			dlg.FilterIndex = 2

			'ファイル保存ダイアログを開きます
			If dlg.ShowDialog = System.Windows.Forms.DialogResult.Cancel Then
				Return
			End If

			'拡張子を付加し、テキストに表示します
			If dlg.FileName.Substring((dlg.FileName.Length - 4), 1) <> "." Then
				Me.txtOutputPath.Text = dlg.FileName & ".xls"
			Else
				Me.txtOutputPath.Text = dlg.FileName
			End If

			'相対参照を行っているのでカレントフォルダをアセンブリに戻しておきます
			System.Environment.CurrentDirectory = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location)

		Catch ex As Exception
			MsgBox(ex.Message)
		End Try

	End Sub

#End Region

#Region "プライベートメソッド"

	'PowerExcel出力処理

	''' <summary>
	''' パワーエクセルプロパティ設定
	''' </summary>
	''' <param name="pwExcel"></param>
	''' <remarks></remarks>
	Private Sub SetPowerExcel(ByVal pwExcel As PowerExcel)
		Try

			'テンプレートを新規モードに設定します
			pwExcel.FileMode = PowerExcel.FileModeEnum.NewFileCreateAndNomalSave

			'ユーザーが選択した保存先ファイルフルパスを設定します
			pwExcel.FilePath = Me.txtOutputPath.Text

			'シート名を設定します
			pwExcel.SheetName = "請求一覧"

			'テンプレートはなし
			'pwExcel.TemplateFilePath = ""
			'pwExcel.TemplateSheetName = ""


		Catch ex As Exception
			MsgBox(MethodBase.GetCurrentMethod().ToString() & "でエラーが発生しました")
			Throw ex
		End Try

	End Sub

	''' <summary>
	''' 単一セルエージェントプロパティ設定
	''' </summary>
	''' <param name="pwExcel"></param>
	''' <remarks></remarks>
	Private Sub SetOneCellAgent(ByVal pwExcel As PowerExcel)

		Try
			'エージェントの内部クラスであるArgumentInfoをインスタンス化します
			Dim argInfo As New AgentForOneCell.ArgumentInfo

			'引数情報クラスのプロパティは全て「m」で始まります
			argInfo.mIntRow = 2
			argInfo.mIntCol = 2
			argInfo.mStrValue = Now.ToString("yyyy/MM/dd") & "日現在"
			argInfo.mFontBold = True
			'設定したArgumentInfoをリストのメンバに追加します
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)

			argInfo = New AgentForOneCell.ArgumentInfo
			argInfo.mIntRow = 2
			argInfo.mIntCol = 8
			argInfo.mStrValue = "担当者　" & Me.T_JishaInfo(0).Tantosha.ToString & " 様"
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)

			argInfo = New AgentForOneCell.ArgumentInfo
			argInfo.mIntRow = 3
			argInfo.mIntCol = 8
			argInfo.mStrValue = "下表の取引先への請求書作成をお願い致します。"
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)

		Catch ex As Exception
			MsgBox(MethodBase.GetCurrentMethod().ToString() & "でエラーが発生しました")
			Throw ex
		End Try

	End Sub

	''' <summary>
	''' データテーブルエージェントプロパティ設定
	''' </summary>
	''' <param name="pwExcel"></param>
	''' <remarks></remarks>
	Private Sub SetDataTableAgent(ByVal pwExcel As PowerExcel)
		Try
	
			'データテーブルを作成します（検索条件が指定されていても無視して全件出力します）
			Dim dtBuf As New SeikyuDataSet.SeikyusakiListDataTable
			dtBuf = Me.T_Seikyu

			'エージェントの内部クラスであるArgumentInfoをインスタンス化します
			Dim argInfo As New AgentForDataTable.ArgumentInfo
			'データテーブルを設定
			argInfo.mDtMain = dtBuf
			argInfo.mIsHeader = True
			argInfo.mHeaderColor = AgentBase.ColorInfoEnum.color25灰色
			argInfo.mIntStartRow = 7
			argInfo.mIntStartCol = 2
			'表のどの個所に罫線を引くかを設定します
			argInfo.mBorderInfo = AgentBase.BorderTypeEnum.B12_ヘッダ囲んで囲む_横点線_縦線
			'罫線のどの部分が中線かを設定します
			argInfo.mBorderWeightInfo = AgentBase.BorderWeightTypeEnum.B04_囲みとヘッダが中線
			'罫線の太さを変更する場合に設定します
			argInfo.mBorderWeightChangeInfo = AgentBase.BorderWeightChangeEnum.B03_中線を太線へ
			'列幅の自動調整を行います
			argInfo.mIsAutoFit = True

			'#######################################################################
			'次に、このデータテーブルのエクセル列情報を追加していきます
			'mIntColはエクセルの表の、1から始まるインデックスを設定します
			'#######################################################################
			Dim colInfo As New AgentForDataTable.ArgumentInfo.ExcelColumn
			'1列目（請求先CD）
			colInfo.mIntCol = 1
			colInfo.mFontBold = True
			colInfo.mBackColor = AgentBase.ColorInfoEnum.color水色
			colInfo.mCellFormat = AgentBase.CellFormatEnum.StringFormat
			argInfo.mExcelColumns.Add(colInfo)
			'2列目（請求先名）
			colInfo = New AgentForDataTable.ArgumentInfo.ExcelColumn
			colInfo.mIntCol = 2
			colInfo.mFontBold = True
			colInfo.mBackColor = AgentBase.ColorInfoEnum.color水色
			argInfo.mExcelColumns.Add(colInfo)
			'4列目（支払予定日）
			colInfo = New AgentForDataTable.ArgumentInfo.ExcelColumn
			colInfo.mIntCol = 4
			colInfo.mFontColor = AgentBase.ColorInfoEnum.color赤
			argInfo.mExcelColumns.Add(colInfo)
			'5列目(金額)
			colInfo = New AgentForDataTable.ArgumentInfo.ExcelColumn
			colInfo.mIntCol = 5
			colInfo.mCellFormat = AgentBase.CellFormatEnum.MoneyFormat
			argInfo.mExcelColumns.Add(colInfo)

			'次に、このデータテーブルエージェントのDataTable列情報を追加していきます
			Dim dtColInfo As New AgentForDataTable.ArgumentInfo.DtColumn
			'非表示扱いにするカラムを設定します
			dtColInfo.mColName = dtBuf.SyohinKbnColumn.ColumnName
			dtColInfo.mIsDelete = True
			argInfo.mDtColumns.Add(dtColInfo)

			dtColInfo = New AgentForDataTable.ArgumentInfo.DtColumn
			dtColInfo.mColName = dtBuf.SyohinKbnNameColumn.ColumnName
			dtColInfo.mIsDelete = True
			argInfo.mDtColumns.Add(dtColInfo)

			dtColInfo = New AgentForDataTable.ArgumentInfo.DtColumn
			dtColInfo.mColName = dtBuf.TelColumn.ColumnName
			dtColInfo.mIsDelete = True
			argInfo.mDtColumns.Add(dtColInfo)

			dtColInfo = New AgentForDataTable.ArgumentInfo.DtColumn
			dtColInfo.mColName = dtBuf.JushoColumn.ColumnName
			dtColInfo.mIsDelete = True
			argInfo.mDtColumns.Add(dtColInfo)

			dtColInfo = New AgentForDataTable.ArgumentInfo.DtColumn
			dtColInfo.mColName = dtBuf.PostColumn.ColumnName
			dtColInfo.mIsDelete = True
			argInfo.mDtColumns.Add(dtColInfo)

			dtColInfo = New AgentForDataTable.ArgumentInfo.DtColumn
			dtColInfo.mColName = dtBuf.FaxColumn.ColumnName
			dtColInfo.mIsDelete = True
			argInfo.mDtColumns.Add(dtColInfo)

			dtColInfo = New AgentForDataTable.ArgumentInfo.DtColumn
			dtColInfo.mColName = dtBuf.BushoColumn.ColumnName
			dtColInfo.mIsDelete = True
			argInfo.mDtColumns.Add(dtColInfo)

			'リストに追加します、このサンプルでは１つの表のみですが、もちろん複数個登録できます
			'ExcelColumnとDtColumnの設定のAddが完了したあとでArgumentListにAddします
			pwExcel.AgentForDataTable.ArgumentList.Add(argInfo)

		Catch ex As Exception
			MsgBox(MethodBase.GetCurrentMethod().ToString() & "でエラーが発生しました")
			Throw ex
		End Try

	End Sub

	''' <summary>
	''' 連続セルエージェントプロパティ設定
	''' </summary>
	''' <param name="pwExcel"></param>
	''' <remarks></remarks>
	Private Sub SetRangingCells(ByVal pwExcel As PowerExcel)
		Try
			'エージェントの内部クラスであるArgumentInfoをインスタンス化します
			Dim argInfo As New AgentForRangingCells.ArgumentInfo
			argInfo.mIntStartRow = 3
			argInfo.mIntStartCol = 2
			argInfo.mIntEndRow = 3
			argInfo.mIntEndCol = 4
			argInfo.mIsJoin = True
			argInfo.mStrValue = "請求書発行一覧表"
			argInfo.mFontBold = True
			argInfo.mFontSize = 14
			argInfo.mBorderInfo = AgentBase.BorderTypeEnum.B02_下線
			argInfo.mBorderWeightInfo = AgentBase.BorderWeightTypeEnum.B08_全て中線
			argInfo.mBorderWeightChangeInfo = AgentBase.BorderWeightChangeEnum.B03_中線を太線へ
			pwExcel.AgentForRangingCells.ArgumentList.Add(argInfo)


			argInfo = New AgentForRangingCells.ArgumentInfo
			argInfo.mIntStartRow = 5
			argInfo.mIntStartCol = 9
			argInfo.mIntEndRow = 7
			argInfo.mIntEndCol = 10
			argInfo.mIsJoin = True
			argInfo.mStrValue = "確認"
			argInfo.mFontBold = True
			argInfo.mFontSize = 21
			argInfo.mHoriAlign = Microsoft.Office.Interop.Excel.XlHAlign.xlHAlignCenter


			argInfo.mFontColor = AgentBase.ColorInfoEnum.color黒
			argInfo.mBackColor = AgentBase.ColorInfoEnum.color黄
			argInfo.mBorderInfo = AgentBase.BorderTypeEnum.B03_囲むだけ
			argInfo.mBorderWeightInfo = AgentBase.BorderWeightTypeEnum.B08_全て中線
			argInfo.mBorderWeightChangeInfo = AgentBase.BorderWeightChangeEnum.B03_中線を太線へ
			pwExcel.AgentForRangingCells.ArgumentList.Add(argInfo)


		Catch ex As Exception
			MsgBox(MethodBase.GetCurrentMethod().ToString() & "でエラーが発生しました")
			Throw ex
		End Try
	End Sub

	''' <summary>
	''' 単一列エージェントプロパティ設定
	''' </summary>
	''' <param name="pwExcel"></param>
	''' <remarks></remarks>
	Private Sub SetOneColumnAgent(ByVal pwExcel As PowerExcel)
		Try

			'エージェントの内部クラスであるArgumentInfoをインスタンス化します
			Dim argInfo As New AgentForOneColumn.ArgumentInfo
			argInfo.mIntCol = 2
			argInfo.mColWidth = 20
			pwExcel.AgentForOneColumn.ArgumentList.Add(argInfo)

			argInfo = New AgentForOneColumn.ArgumentInfo
			argInfo.mIntCol = 3
			argInfo.mColWidth = 20
			pwExcel.AgentForOneColumn.ArgumentList.Add(argInfo)

			argInfo = New AgentForOneColumn.ArgumentInfo
			argInfo.mIntCol = 4
			argInfo.mColWidth = 10
			pwExcel.AgentForOneColumn.ArgumentList.Add(argInfo)

			argInfo = New AgentForOneColumn.ArgumentInfo
			argInfo.mIntCol = 5
			argInfo.mColWidth = 10
			argInfo.mColAutoFit = True
			pwExcel.AgentForOneColumn.ArgumentList.Add(argInfo)

			argInfo = New AgentForOneColumn.ArgumentInfo
			argInfo.mIntCol = 6
			argInfo.mColWidth = 20
			pwExcel.AgentForOneColumn.ArgumentList.Add(argInfo)

		Catch ex As Exception
			MsgBox(MethodBase.GetCurrentMethod().ToString() & "でエラーが発生しました")
			Throw ex
		End Try
	End Sub



	'PageExcel出力処理

	''' <summary>
	''' ページエクセルプロパティ設定
	''' </summary>
	''' <param name="pwExcel"></param>
	''' <remarks></remarks>
	Private Sub SetPageExcel(ByVal pwExcel As PageExcel)
		Try

			'テンプレートを読み込むモードに設定します
			pwExcel.FileMode = PowerExcel.FileModeEnum.OpenFileAndNomalSave

			'ユーザーが選択した保存先ファイルフルパスを設定します
			pwExcel.FilePath = Me.txtOutputPath.Text

			'シート名はシート毎に設定するのでこのプロパティは使用しません
			pwExcel.SheetName = ""

			'テンプレート
			pwExcel.TemplateFilePath = "..\..\..\Doc\請求書テンプレート.xls"
			pwExcel.TemplateSheetName = "Sheet1"

			'ヘッダデータテーブルを設定します
			pwExcel.DtHead = Me.T_Seikyu

			'全明細データを設定します
			pwExcel.DtDetail = Me.T_SeikyuDetail

			'シート名に設定するカラムを設定します（設定しない場合は１から連番）
			pwExcel.SheetColumn = Me.T_Seikyu.SeikyusakiNameColumn

			'シート名の前に１から連番を挿入します（シート名が重複しても落とさないように）
			pwExcel.IsSheetNameCountUp = True

			'改ページのキーカラムを設定します
			'注意）
			'　　改ページのキーカラムはヘッダと明細で必ず同じ名前にしておく必要があります
			'　　ヘッダのレコード分、シートが作成され、そのシートと明細をリンクさせるためのキーです
			pwExcel.KeyColumns.Add(Me.T_Seikyu.SeikyusakiCDColumn)


		Catch ex As Exception
			MsgBox(MethodBase.GetCurrentMethod().ToString() & "でエラーが発生しました")
			Throw ex
		End Try

	End Sub

	''' <summary>
	''' 単一セルエージェントプロパティ設定
	''' </summary>
	''' <param name="pwExcel"></param>
	''' <remarks></remarks>
	Private Sub SetOneCellAgent(ByVal pwExcel As PageExcel)

		Try
			'エージェントの内部クラスであるArgumentInfoをインスタンス化します
			Dim argInfo As New AgentForOneCell.ArgumentInfo

			'引数情報クラスのプロパティは全て「m」で始まります
			argInfo.mIntRow = 5
			argInfo.mIntCol = 10
			argInfo.mStrValue = Now.ToString("yyyy/MM/dd")
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)

			argInfo = New AgentForOneCell.ArgumentInfo
			argInfo.mIntRow = 6
			argInfo.mIntCol = 11
			argInfo.mStrValue = "123456"
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)

			'自社情報を設定していきます
			'自社名
			argInfo = New AgentForOneCell.ArgumentInfo
			argInfo.mIntRow = 10
			argInfo.mIntCol = 8
			argInfo.mStrValue = Me.T_JishaInfo(0).JishaName
			argInfo.mCellFormat = AgentBase.CellFormatEnum.StringFormat
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)
			'郵便番号
			argInfo = New AgentForOneCell.ArgumentInfo
			argInfo.mIntRow = 12
			argInfo.mIntCol = 9
			argInfo.mStrValue = Me.T_JishaInfo(0).Post
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)
			'住所
			argInfo = New AgentForOneCell.ArgumentInfo
			argInfo.mIntRow = 13
			argInfo.mIntCol = 8
			argInfo.mStrValue = Me.T_JishaInfo(0).Jusho
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)
			'TEL
			argInfo = New AgentForOneCell.ArgumentInfo
			argInfo.mIntRow = 15
			argInfo.mIntCol = 9
			argInfo.mStrValue = Me.T_JishaInfo(0).Tel
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)
			'FAX
			argInfo = New AgentForOneCell.ArgumentInfo
			argInfo.mIntRow = 16
			argInfo.mIntCol = 9
			argInfo.mStrValue = Me.T_JishaInfo(0).Fax
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)
			'部署
			argInfo = New AgentForOneCell.ArgumentInfo
			argInfo.mIntRow = 17
			argInfo.mIntCol = 8
			argInfo.mStrValue = Me.T_JishaInfo(0).Busho
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)
			'社員名
			argInfo = New AgentForOneCell.ArgumentInfo
			argInfo.mIntRow = 19
			argInfo.mIntCol = 10
			argInfo.mStrValue = Me.T_JishaInfo(0).Tantosha
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)
			'振り込み先
			argInfo = New AgentForOneCell.ArgumentInfo
			argInfo.mIntRow = 49
			argInfo.mIntCol = 2
			argInfo.mStrValue = Me.T_JishaInfo(0).bank
			pwExcel.AgentForOneCell.ArgumentList.Add(argInfo)

		Catch ex As Exception
			MsgBox(MethodBase.GetCurrentMethod().ToString() & "でエラーが発生しました")
			Throw ex
		End Try

	End Sub

	''' <summary>
	''' ヘッダデータテーブルエージェントプロパティ設定
	''' </summary>
	''' <param name="pwExcel"></param>
	''' <remarks></remarks>
	Private Sub SetPageHeadAgent(ByVal pwExcel As PageExcel)

		Try

			'エージェントの内部クラスであるArgumentInfoをインスタンス化します
			Dim argInfo As New AgentForPageHead.ArgumentInfo

			'値を設定するのではなく、リンクするカラム名を設定します

			'請求先名称
			argInfo = New AgentForPageHead.ArgumentInfo
			argInfo.mIntRow = 8
			argInfo.mIntCol = 2
			argInfo.mStrColName = Me.T_Seikyu.SeikyusakiNameColumn.ColumnName
			argInfo.mStrAfterValue = "　御中"
			pwExcel.AgentForPageHead.ArgumentList.Add(argInfo)
			'郵便番号
			argInfo = New AgentForPageHead.ArgumentInfo
			argInfo.mIntRow = 10
			argInfo.mIntCol = 3
			argInfo.mStrColName = Me.T_Seikyu.PostColumn.ColumnName
			pwExcel.AgentForPageHead.ArgumentList.Add(argInfo)
			'住所
			argInfo = New AgentForPageHead.ArgumentInfo
			argInfo.mIntRow = 11
			argInfo.mIntCol = 2
			argInfo.mStrColName = Me.T_Seikyu.JushoColumn.ColumnName
			pwExcel.AgentForPageHead.ArgumentList.Add(argInfo)
			'TEL
			argInfo = New AgentForPageHead.ArgumentInfo
			argInfo.mIntRow = 13
			argInfo.mIntCol = 3
			argInfo.mStrColName = Me.T_Seikyu.TelColumn.ColumnName
			pwExcel.AgentForPageHead.ArgumentList.Add(argInfo)
			'FAX
			argInfo = New AgentForPageHead.ArgumentInfo
			argInfo.mIntRow = 14
			argInfo.mIntCol = 3
			argInfo.mStrColName = Me.T_Seikyu.FaxColumn.ColumnName
			pwExcel.AgentForPageHead.ArgumentList.Add(argInfo)
			'部署名
			argInfo = New AgentForPageHead.ArgumentInfo
			argInfo.mIntRow = 15
			argInfo.mIntCol = 2
			argInfo.mStrColName = Me.T_Seikyu.BushoColumn.ColumnName
			pwExcel.AgentForPageHead.ArgumentList.Add(argInfo)
			'担当者
			argInfo = New AgentForPageHead.ArgumentInfo
			argInfo.mIntRow = 17
			argInfo.mIntCol = 3
			argInfo.mStrColName = Me.T_Seikyu.TantoshaColumn.ColumnName
			pwExcel.AgentForPageHead.ArgumentList.Add(argInfo)

		Catch ex As Exception
			MsgBox(MethodBase.GetCurrentMethod().ToString() & "でエラーが発生しました")
			Throw ex
		End Try

	End Sub

	''' <summary>
	''' データテーブルエージェントプロパティ設定
	''' </summary>
	''' <param name="pwExcel"></param>
	''' <remarks></remarks>
	Private Sub SetDataTableAgent(ByVal pwExcel As PageExcel)
		Try

			'エージェントの内部クラスであるArgumentInfoをインスタンス化します
			Dim argInfo As New AgentForDataTable.ArgumentInfo
			'注意）
			'データテーブルは設定しません、表の設定のみ行います
			'設定したとしても、ページエクセルが、シート毎に上書きしています
			'argInfo.mDtMain = 
			'ヘッダはテンプレートに書かれてあるので非表示にします
			argInfo.mIsHeader = False
			argInfo.mIntStartRow = 23
			argInfo.mIntStartCol = 2

			'#######################################################################
			'次に、このデータテーブルのエクセル列情報を追加していきます
			'mIntColはエクセルの表の、1から始まるインデックスを設定します
			'データテーブルのインデックスではありません、又、仮にセルが結合されていたとしても
			'結合を気にせず設定できます
			'例えば、2列目が4列結合されていたとしても、3列目は6ではなく3です
			'#######################################################################
			Dim colInfo As New AgentForDataTable.ArgumentInfo.ExcelColumn
			'2列目（商品名を太字にしてみます）
			colInfo.mIntCol = 2
			colInfo.mFontBold = True

			argInfo.mExcelColumns.Add(colInfo)

			'次に、データテーブルの列情報を設定します
			Dim dtColInfo As New AgentForDataTable.ArgumentInfo.DtColumn
			'非表示列を設定します
			dtColInfo.mColName = Me.T_SeikyuDetail.SeikyusakiCDColumn.ColumnName
			dtColInfo.mIsDelete = True
			argInfo.mDtColumns.Add(dtColInfo)

			dtColInfo = New AgentForDataTable.ArgumentInfo.DtColumn
			dtColInfo.mColName = Me.T_SeikyuDetail.ShohinKbnColumn.ColumnName
			dtColInfo.mIsDelete = True
			argInfo.mDtColumns.Add(dtColInfo)

			'リストに追加します、ページエクセルは複数個の表の描画には対応していません、１シート１表です
			'ExcelColumnとDtColumnの設定のAddが完了したあとでArgumentListにAddします
			pwExcel.AgentForDataTable.ArgumentList.Add(argInfo)

		Catch ex As Exception
			MsgBox(MethodBase.GetCurrentMethod().ToString() & "でエラーが発生しました")
			Throw ex
		End Try

	End Sub
#End Region


End Class
